﻿Imports System.Xml.Serialization
Imports System.IO
Imports System.Net
Imports System.Drawing


Public Module modSettings
    ' This module is responsible for saveing and loading the User Settings file


    '  Obsolete
    Dim boolShowMore As Boolean = False
    Dim boolRemoteKinect As Boolean = False
    Dim boolEnableBotSerialIF As Boolean = False
    Dim boolPCVoice As Boolean = False
    Dim boolVerboseLogFile As Boolean = False
    Dim boolEnableEvolutionIR_ER1 As Boolean = False
    Dim boolEnableRangerAveraging As Boolean = False
    Dim boolEnableYRotation As Boolean = False
    Dim boolEnableBotRCC As Boolean = False
    Dim intRobot_Port As Integer = 0
    'Dim intVideoSource As Integer = 0  ' was intEvolution_IR_Threshold
    Dim sngGridSize As Single = 1
    Dim strUnits As String = "inch"
    Dim ipKinectAddress As IPAddress = IPAddress.Parse("127.0.0.1".Trim)
    Dim ipRobot_IPAddress As IPAddress = IPAddress.Parse("127.0.0.1".Trim)
    Dim sngAngularVelocityCorrectionFactor As Single = 0.65   ' 
    '  Obsolete



    Public Sub SaveSettings(ByVal strFileName As String)
        Try
            Dim GotABot_Settings As New BotSettings With {
            .xml_tmcDock = tmcDock,
            .xml_boolDockBackIn = boolDockBackIn,
            .xml_intDockOrientation = intDockOrientation,
            .xml_intDockTriggerPC = intDockTriggerPC,
            .xml_sngDockTriggerBot = sngDockTriggerBot,
            .xml_boolRemoteKinect = boolRemoteKinect,
            .xml_sngScanFOV = sngScanFOV,
            .xml_sngScannerCalibrate = sngScannerCalibrate,
            .xml_sngScannerCurveAdjust = sngScannerCurveAdjust,
            .xml_intScanOffsetDegrees = intScanOffsetDegrees,
            .xml_ipKinectAddress = Convert.ToString(ipKinectAddress),
            .xml_tmcDestinationAlpha = tmcDestinationAlpha,
            .xml_tmcDestinationBravo = tmcDestinationBravo,
            .xml_tmcDestinationCharlie = tmcDestinationCharlie,
            .xml_tmcDestinationDelta = tmcDestinationDelta,
            .xml_tmcDestinationEcho = tmcDestinationEcho,
            .xml_tmcScanVectorOffset = tmcScanVectorOffset,
            .xml_intNumberOfBeams = intNumberOfBeams,
            .xml_intNumberOfParticles = intNumberOfParticles,
            .xml_intDefaultElevation = intDefaultElevation,
            .xml_Robot_IPAddress = Convert.ToString(ipRobot_IPAddress),
            .xml_Robot_Port = intRobot_Port,
            .xml_sngLocalizationTime = sngLocalizationTime,
            .xml_intCompassOrientationOffset = intCompassOrientationOffset,
            .xml_sngAngularVelocityCorrectionFactor = sngAngularVelocityCorrectionFactor,
            .xml_sngSteeringBiasOffsetCorrection = sngSteeringBiasOffsetCorrection,
            .xml_sngDistanceCorrectionCoeff_x0 = sngDistanceCorrectionCoeff_x0,
            .xml_sngDistanceCorrectionCoeff_x1 = sngDistanceCorrectionCoeff_x1,
            .xml_sngDistanceCorrectionCoeff_x2 = sngDistanceCorrectionCoeff_x2,
            .xml_sngBotLinearAcceleration = sngBotLinearAcceleration,
            .xml_sngBotLinearVelocity = sngBotLinearVelocity,
            .xml_sngBotAngularVelocity = sngBotAngularVelocity,
            .xml_sngBotAngularAcceleration = sngBotAngularAcceleration,
            .xml_sngBotWheelSeparation = sngBotWheelSeparation,
            .xml_intPowerMoving = intPowerMoving,
            .xml_intPowerStopped = intPowerStopped,
            .xml_intNumberOfBeamsDefault = intNumberOfBeamsDefault,
            .xml_strNewsURL = strNewsURL,
            .xml_strWeatherURL = strWeatherURL,
            .xml_strPassword = strPassword,
            .xml_sngBotDiameter = sngBotDiameter,
            .xml_sngCameraOffset = sngCameraOffset,
            .xml_sngCameraFOV = sngCameraFOV,
            .xml_ticCameraResolution = ticCameraResolution,
            .xml_sngBotMovementAccuracy = sngBotMovementAccuracy,
            .xml_sngMaxTravel = sngMaxTravel,
            .xml_sngZoom = sngZoom,
            .xml_sngGridSize = sngGridSize,
            .xml_strBotComPort = strBotComPort,
            .xml_strURGComPort = strURGComPort,
            .xml_strUnits = strUnits,
            .xml_tbpBotPose = tbpBotPose,
            .xml_trfRangeFinders = trfRangeFinders,
            .xml_intRangeCorrectionFactor = intRangeCorrectionFactor,
            .xml_LandMark = tlmLandMarkArray,
            .xml_RangeLandMark = tlm2DScanLandMarkArray,
            .xml_boolShowMore = boolShowMore,
            .xml_boolEnableBotSerialIF = boolEnableBotSerialIF,
            .xml_boolPCVoice = boolPCVoice,
            .xml_boolVoiceCommandEnable = boolVoiceCommandEnable,
            .xml_boolVerboseLogFile = boolVerboseLogFile,
            .xml_boolEnableYRotation = boolEnableYRotation,
            .xml_boolSimulatedMovement = boolSimulatedMovement,
            .xml_mnuEnableLocalRCC = boolEnableLocalRCC,
            .xml_mnuEnableGotAGlyph = boolEnableGotAGlyph,
            .xml_mnuEnableArm = boolEnableArm,
            .xml_mnuboolEnableFaceRecognition = boolEnableFaceRecognition,
            .xml_mnuboolEnableVideo = boolEnableVideo,
            .xml_mnuEnableAVM = boolEnableAVM,
            .xml_mnuEnableLocalRR = boolEnableLocalRR,
            .xml_mnuEnableBotRCC = boolEnableLocalRCC,
            .xml_boolViewLM = boolViewLM,
            .xml_boolViewDebug = boolViewDebug,
            .xml_boolEnableLocalizationWhileMoving = boolEnableLocalizationWhileMoving,
            .xml_boolEnableCourseCorrection = boolEnableCourseCorrection,
            .xml_boolEnableRBPF = boolEnableRBPF,
            .xml_boolEnableXY_Motion = boolEnableCurveMotion,
            .xml_boolMute = boolMute,
            .xml_boolLogFileEnable = boolLogFileEnable,
            .xml_boolHeroSelected = boolHeroSelected,
            .xml_boolER1Selected = boolER1Selected,
            .xml_boolEnableBumperSwitches_ER1 = boolEnableBumperSwitches_ER1,
            .xml_boolEnableEvolutionIR_ER1 = boolEnableEvolutionIR_ER1,
            .xml_intVideoSource = intVideoSource,
            .xml_boolEnableRangerAveraging = boolEnableRangerAveraging,
            .xml_boolRoboRealmBotSelected = boolRoboRealmBotSelected,
            .xml_boolAllowRoboRealmToControlBot = boolAllowRoboRealmToControlBot}
            GotABot_Settings.SaveSettingsXml(strFileName)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in SaveSettings")
        End Try
    End Sub



    Public Sub LoadSettings(ByVal strFileName As String)
        Try
            Dim GotABot_Settings As BotSettings = BotSettings.LoadSettingsXml(strFileName)
            tmcDock = GotABot_Settings.xml_tmcDock
            intDockOrientation = GotABot_Settings.xml_intDockOrientation
            intDockTriggerPC = GotABot_Settings.xml_intDockTriggerPC
            sngDockTriggerBot = GotABot_Settings.xml_sngDockTriggerBot
            boolDockBackIn = GotABot_Settings.xml_boolDockBackIn
            boolRemoteKinect = GotABot_Settings.xml_boolRemoteKinect
            sngScanFOV = GotABot_Settings.xml_sngScanFOV
            If (sngScanFOV = 0) Then sngScanFOV = 58.5
            sngScannerCalibrate = GotABot_Settings.xml_sngScannerCalibrate
            If (sngScannerCalibrate = 0) Then sngScannerCalibrate = 1
            sngScannerCurveAdjust = GotABot_Settings.xml_sngScannerCurveAdjust
            intScanOffsetDegrees = GotABot_Settings.xml_intScanOffsetDegrees
            ipKinectAddress = IPAddress.Parse(GotABot_Settings.xml_ipKinectAddress.Trim)
            intNumberOfBeams = GotABot_Settings.xml_intNumberOfBeams
            intNumberOfParticles = GotABot_Settings.xml_intNumberOfParticles
            If (intNumberOfParticles = 0) Then intNumberOfParticles = 32
            intDefaultElevation = GotABot_Settings.xml_intDefaultElevation
            tmcDestinationAlpha = GotABot_Settings.xml_tmcDestinationAlpha
            tmcDestinationBravo = GotABot_Settings.xml_tmcDestinationBravo
            tmcDestinationCharlie = GotABot_Settings.xml_tmcDestinationCharlie
            tmcDestinationDelta = GotABot_Settings.xml_tmcDestinationDelta
            tmcDestinationEcho = GotABot_Settings.xml_tmcDestinationEcho
            tmcScanVectorOffset = GotABot_Settings.xml_tmcScanVectorOffset
            ipRobot_IPAddress = IPAddress.Parse(GotABot_Settings.xml_Robot_IPAddress.Trim)
            intRobot_Port = GotABot_Settings.xml_Robot_Port
            sngLocalizationTime = GotABot_Settings.xml_sngLocalizationTime
            intCompassOrientationOffset = GotABot_Settings.xml_intCompassOrientationOffset
            sngAngularVelocityCorrectionFactor = GotABot_Settings.xml_sngAngularVelocityCorrectionFactor
            sngSteeringBiasOffsetCorrection = GotABot_Settings.xml_sngSteeringBiasOffsetCorrection
            sngDistanceCorrectionCoeff_x0 = GotABot_Settings.xml_sngDistanceCorrectionCoeff_x0
            sngDistanceCorrectionCoeff_x1 = GotABot_Settings.xml_sngDistanceCorrectionCoeff_x1
            sngDistanceCorrectionCoeff_x2 = GotABot_Settings.xml_sngDistanceCorrectionCoeff_x2
            If (sngDistanceCorrectionCoeff_x0 = 0) And (sngDistanceCorrectionCoeff_x1 = 0) And (sngDistanceCorrectionCoeff_x2 = 0) Then
                sngDistanceCorrectionCoeff_x0 = 0.0924
                sngDistanceCorrectionCoeff_x1 = 0.8986
                sngDistanceCorrectionCoeff_x2 = -0.0059
            End If
            sngBotLinearAcceleration = GotABot_Settings.xml_sngBotLinearAcceleration
            If (sngBotLinearAcceleration <= 0) Then sngBotLinearAcceleration = 1
            sngBotLinearVelocity = GotABot_Settings.xml_sngBotLinearVelocity
            sngBotAngularVelocity = GotABot_Settings.xml_sngBotAngularVelocity
            sngBotAngularAcceleration = GotABot_Settings.xml_sngBotAngularAcceleration
            If (sngBotAngularAcceleration <= 0) Then sngBotAngularAcceleration = 1
            sngBotWheelSeparation = GotABot_Settings.xml_sngBotWheelSeparation
            If (sngBotWheelSeparation <= 0) Then sngBotWheelSeparation = 38
            If boolBotConnected Then
                ftnSendCommand("set linear velocity " & Int(sngBotLinearVelocity).ToString)
                ftnSendCommand("set angular velocity  " & Int(sngBotAngularVelocity).ToString)
            End If
            intPowerMoving = GotABot_Settings.xml_intPowerMoving
            intPowerMoving = GotABot_Settings.xml_intPowerMoving
            If (intPowerMoving = 0) Then intPowerMoving = 80
            intPowerStopped = GotABot_Settings.xml_intPowerStopped
            intNumberOfBeamsDefault = 32 ' GotABot_Settings.xml_intNumberOfBeamsDefault
            'If (intNumberOfBeamsDefault = 0) Then intNumberOfBeamsDefault = 32
            If (GotABot_Settings.xml_strNewsURL <> "") Then strNewsURL = GotABot_Settings.xml_strNewsURL
            If (GotABot_Settings.xml_strWeatherURL <> "") Then strWeatherURL = GotABot_Settings.xml_strWeatherURL
            strPassword = GotABot_Settings.xml_strPassword
            sngBotDiameter = GotABot_Settings.xml_sngBotDiameter
            sngCameraFOV = GotABot_Settings.xml_sngCameraFOV
            ticCameraResolution = GotABot_Settings.xml_ticCameraResolution
            sngBotMovementAccuracy = GotABot_Settings.xml_sngBotMovementAccuracy
            sngCameraOffset = GotABot_Settings.xml_sngCameraOffset
            sngMaxTravel = GotABot_Settings.xml_sngMaxTravel
            sngZoom = GotABot_Settings.xml_sngZoom
            sngGridSize = GotABot_Settings.xml_sngGridSize
            If (sngGridSize <= 0) Then sngGridSize = 1
            strBotComPort = GotABot_Settings.xml_strBotComPort
            If (strBotComPort = "") Then strBotComPort = "None"
            strURGComPort = GotABot_Settings.xml_strURGComPort
            If (strURGComPort = "") Then strURGComPort = "None"
            strUnits = GotABot_Settings.xml_strUnits
            tbpBotPose = GotABot_Settings.xml_tbpBotPose
            For i = 0 To UBound(trfRangeFinders)
                trfRangeFinders(i) = GotABot_Settings.xml_trfRangeFinders(i)
            Next
            For i = 0 To UBound(intRangeCorrectionFactor)
                intRangeCorrectionFactor(i) = GotABot_Settings.xml_intRangeCorrectionFactor(i)
            Next
            tlmLandMarkArray = GotABot_Settings.xml_LandMark
            tlm2DScanLandMarkArray = GotABot_Settings.xml_RangeLandMark
            boolEnableBotSerialIF = GotABot_Settings.xml_boolEnableBotSerialIF
            boolPCVoice = GotABot_Settings.xml_boolPCVoice
            boolVoiceCommandEnable = GotABot_Settings.xml_boolVoiceCommandEnable
            boolShowMore = True
            boolVerboseLogFile = GotABot_Settings.xml_boolVerboseLogFile
            boolEnableYRotation = GotABot_Settings.xml_boolEnableYRotation
            boolSimulatedMovement = GotABot_Settings.xml_boolSimulatedMovement
            boolEnableLocalRCC = GotABot_Settings.xml_mnuEnableLocalRCC
            boolEnableGotAGlyph = GotABot_Settings.xml_mnuEnableGotAGlyph
            boolEnableArm = GotABot_Settings.xml_mnuEnableArm
            boolEnableFaceRecognition = GotABot_Settings.xml_mnuboolEnableFaceRecognition
            boolEnableVideo = GotABot_Settings.xml_mnuboolEnableVideo
            boolEnableAVM = GotABot_Settings.xml_mnuEnableAVM
            boolEnableLocalRR = GotABot_Settings.xml_mnuEnableLocalRR
            boolEnableBotRCC = GotABot_Settings.xml_mnuEnableBotRCC
            boolViewLM = GotABot_Settings.xml_boolViewLM
            boolViewDebug = GotABot_Settings.xml_boolViewDebug
            boolEnableLocalizationWhileMoving = GotABot_Settings.xml_boolEnableLocalizationWhileMoving
            boolEnableCourseCorrection = GotABot_Settings.xml_boolEnableCourseCorrection
            boolEnableRBPF = False  ' NOTE NOTE NOTE GotABot_Settings.xml_boolEnableRBPF
            boolEnableCurveMotion = GotABot_Settings.xml_boolEnableXY_Motion
            boolMute = GotABot_Settings.xml_boolMute
            boolLogFileEnable = GotABot_Settings.xml_boolLogFileEnable
            boolHeroSelected = GotABot_Settings.xml_boolHeroSelected
            boolER1Selected = GotABot_Settings.xml_boolER1Selected
            boolEnableBumperSwitches_ER1 = GotABot_Settings.xml_boolEnableBumperSwitches_ER1
            boolEnableEvolutionIR_ER1 = GotABot_Settings.xml_boolEnableEvolutionIR_ER1
            intVideoSource = GotABot_Settings.xml_intVideoSource
            boolEnableRangerAveraging = GotABot_Settings.xml_boolEnableRangerAveraging   ' unused
            boolRoboRealmBotSelected = GotABot_Settings.xml_boolRoboRealmBotSelected
            boolAllowRoboRealmToControlBot = GotABot_Settings.xml_boolAllowRoboRealmToControlBot
            If (sngGridSize <> 1) Or (strUnits <> "inch") Then
                MsgBox("WARNING: Map grid size is now fixed at 1 grid square = 1 inch.")
                strUnits = "inch"
                sngGridSize = 1
            End If
            If Not (boolRoboRealmBotSelected Or boolER1Selected Or boolHeroSelected) Then MsgBox("WARNING: No Bot selected")
            If boolEnableBotRCC And Not (boolER1Selected Or boolHeroSelected) Then
                MsgBox("WARNING: RCC Control of ER1 is obsolete")
                boolEnableBotRCC = False
            End If
            If boolEnableEvolutionIR_ER1 Then
                MsgBox("WARNING: The Evolution IR interface is obsolete")
                boolEnableEvolutionIR_ER1 = False
            End If
            If boolEnableYRotation Then
                MsgBox("WARNING:  Y Rotation is obsolete")
                boolEnableYRotation = False
            End If
            subRecalculateVariables()
            ftnSetMoveInfo(TypeOfMove.NONE, tbpBotPose, tbpBotPose, True)
            ftnSetMoveInfo(TypeOfMove.NONE, tbpBotPose, tbpBotPose, False)
            tmiMoveInfo.boolMoveCommandInProgress = False
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in LoadSettings")
        End Try
    End Sub



    Public Class BotSettings
        Private _xml_tmcDock As typeMapCoordinate
        Private _xml_intDockOrientation As Integer
        Private _xml_intDockTriggerPC As Integer
        Private _xml_boolDockBackIn As Boolean
        Private _xml_sngDockTriggerBot As Single
        Private _xml_boolRemoteKinect As Boolean
        Private _xml_sngScanFOV As Single
        Private _xml_sngScannerCalibrate As Single
        Private _xml_sngScannerCurveAdjust As Single
        Private _xml_intScanOffsetDegrees As Short
        Private _xml_ipKinectAddress As String
        Private _xml_tmcDestinationAlpha As typeMapCoordinate
        Private _xml_tmcDestinationBravo As typeMapCoordinate
        Private _xml_tmcDestinationCharlie As typeMapCoordinate
        Private _xml_tmcDestinationDelta As typeMapCoordinate
        Private _xml_tmcDestinationEcho As typeMapCoordinate
        Private _xml_tmcScanVectorOffset As typeMapCoordinate
        Private _xml_intNumberOfBeams As Integer
        Private _xml_intNumberOfParticles As Integer
        Private _xml_intDefaultElevation As Integer
        Private _xml_Robot_IPAddress As String
        Private _xml_Robot_Port As Integer
        Private _xml_sngSteeringBiasOffsetCorrection As Single
        Private _xml_sngDistanceCorrectionCoeff_x0 As Single
        Private _xml_sngDistanceCorrectionCoeff_x1 As Single
        Private _xml_sngDistanceCorrectionCoeff_x2 As Single
        Private _xml_sngBotLinearAcceleration As Single
        Private _xml_sngBotLinearVelocity As Single
        Private _xml_sngBotAngularVelocity As Single
        Private _xml_sngBotAngularAcceleration As Single
        Private _xml_sngBotWheelSeparation As Single
        Private _xml_intPowerMoving As Integer
        Private _xml_intPowerStopped As Integer
        Private _xml_intNumberOfBeamsDefault As Integer
        Private _xml_sngLocalizationTime As Single
        Private _xml_intCompassOrientationOffset As Integer
        Private _xml_sngAngularVelocityCorrectionFactor As Single
        Private _xml_strNewsURL As String
        Private _xml_strWeatherURL As String
        Private _xml_strPassword As String
        Private _xml_sngBotDiameter As Single
        Private _xml_sngCameraFOV As Single
        Private _xml_ticCameraResolution As typeImageCoordinate
        Private _xml_sngBotMovementAccuracy As Single
        Private _xml_sngCameraOffset As Single
        Private _xml_sngMaxTravel As Single
        Private _xml_sngZoom As Single
        Private _xml_sngGridSize As Single
        Private _xml_strBotComPort As String
        Private _xml_strURGComPort As String
        Private _xml_strUnits As String
        Private _xml_tbpBotPose As typeBotPose
        Private _xml_trfRangeFinders(64) As typeRangeFinder
        Private _xml_intRangeCorrectionFactor(UBound(intRangeCorrectionFactor)) As Integer
        Private _xml_LandMark(128) As typeLandMark
        Private _xml_RangeLandMark(128) As typeLandMark
        Private _xml_boolEnableBotSerialIF As Boolean
        Private _xml_boolPCVoice As Boolean
        Private _xml_boolVoiceCommandEnable As Boolean
        Private _xml_boolShowMore As Boolean
        Private _xml_boolVerboseLogFile As Boolean
        Private _xml_boolEnableYRotation As Boolean
        Private _xml_boolSimulatedMovement As Boolean
        Private _xml_mnuEnableLocalRCC As Boolean
        Private _xml_mnuEnableGotAGlyph As Boolean
        Private _xml_mnuEnableArm As Boolean
        Private _xml_mnuboolEnableFaceRecognition As Boolean
        Private _xml_mnuboolEnableVideo As Boolean
        Private _xml_mnuEnableAVM As Boolean
        Private _xml_mnuEnableLocalRR As Boolean
        Private _xml_mnuEnableBotRCC As Boolean
        Private _xml_boolViewLM As Boolean
        Private _xml_boolViewDebug As Boolean
        Private _xml_boolEnableLocalizationWhileMoving As Boolean
        Private _xml_boolEnableCourseCorrection As Boolean
        Private _xml_boolEnableRBPF As Boolean
        Private _xml_boolEnableXY_Motion As Boolean
        Private _xml_boolMute As Boolean
        Private _xml_boolLogFileEnable As Boolean
        Private _xml_boolHeroSelected As Boolean
        Private _xml_boolER1Selected As Boolean
        Private _xml_boolEnableBumperSwitches_ER1 As Boolean
        Private _xml_boolEnableEvolutionIR_ER1 As Boolean
        Private _xml_intVideoSource As Integer
        Private _xml_boolEnableRangerAveraging As Boolean
        Private _xml_boolRoboRealmBotSelected As Boolean
        Private _xml_boolAllowRoboRealmToControlBot As Boolean

        Public Property xml_tmcDock() As typeMapCoordinate
            Get
                Return _xml_tmcDock
            End Get
            Set(ByVal value As typeMapCoordinate)
                _xml_tmcDock = value
            End Set
        End Property

        Public Property xml_intDockOrientation() As Integer
            Get
                Return _xml_intDockOrientation
            End Get
            Set(ByVal value As Integer)
                _xml_intDockOrientation = value
            End Set
        End Property

        Public Property xml_intDockTriggerPC() As Integer
            Get
                Return _xml_intDockTriggerPC
            End Get
            Set(ByVal value As Integer)
                _xml_intDockTriggerPC = value
            End Set
        End Property

        Public Property xml_sngDockTriggerBot() As Single
            Get
                Return _xml_sngDockTriggerBot
            End Get
            Set(ByVal value As Single)
                _xml_sngDockTriggerBot = value
            End Set
        End Property

        Public Property xml_boolDockBackIn() As Boolean
            Get
                Return _xml_boolDockBackIn
            End Get
            Set(ByVal value As Boolean)
                _xml_boolDockBackIn = value
            End Set
        End Property

        Public Property xml_boolRemoteKinect() As Boolean
            Get
                Return _xml_boolRemoteKinect
            End Get
            Set(ByVal value As Boolean)
                _xml_boolRemoteKinect = value
            End Set
        End Property

        Public Property xml_sngScanFOV() As Single
            Get
                Return _xml_sngScanFOV
            End Get
            Set(ByVal value As Single)
                _xml_sngScanFOV = value
            End Set
        End Property

        Public Property xml_sngScannerCalibrate() As Single
            Get
                Return _xml_sngScannerCalibrate
            End Get
            Set(ByVal value As Single)
                _xml_sngScannerCalibrate = value
            End Set
        End Property

        Public Property xml_sngScannerCurveAdjust() As Single
            Get
                Return _xml_sngScannerCurveAdjust
            End Get
            Set(ByVal value As Single)
                _xml_sngScannerCurveAdjust = value
            End Set
        End Property

        Public Property xml_intScanOffsetDegrees() As Short
            Get
                Return _xml_intScanOffsetDegrees
            End Get
            Set(ByVal value As Short)
                _xml_intScanOffsetDegrees = value
            End Set
        End Property

        Public Property xml_ipKinectAddress() As String
            Get
                Return _xml_ipKinectAddress
            End Get
            Set(ByVal value As String)
                _xml_ipKinectAddress = value
            End Set
        End Property

        Public Property xml_tmcDestinationAlpha() As typeMapCoordinate
            Get
                Return _xml_tmcDestinationAlpha
            End Get
            Set(ByVal value As typeMapCoordinate)
                _xml_tmcDestinationAlpha = value
            End Set
        End Property

        Public Property xml_tmcDestinationBravo() As typeMapCoordinate
            Get
                Return _xml_tmcDestinationBravo
            End Get
            Set(ByVal value As typeMapCoordinate)
                _xml_tmcDestinationBravo = value
            End Set
        End Property

        Public Property xml_tmcDestinationCharlie() As typeMapCoordinate
            Get
                Return _xml_tmcDestinationCharlie
            End Get
            Set(ByVal value As typeMapCoordinate)
                _xml_tmcDestinationCharlie = value
            End Set
        End Property

        Public Property xml_tmcDestinationDelta() As typeMapCoordinate
            Get
                Return _xml_tmcDestinationDelta
            End Get
            Set(ByVal value As typeMapCoordinate)
                _xml_tmcDestinationDelta = value
            End Set
        End Property

        Public Property xml_tmcDestinationEcho() As typeMapCoordinate
            Get
                Return _xml_tmcDestinationEcho
            End Get
            Set(ByVal value As typeMapCoordinate)
                _xml_tmcDestinationEcho = value
            End Set
        End Property

        Public Property xml_tmcScanVectorOffset() As typeMapCoordinate
            Get
                Return _xml_tmcScanVectorOffset
            End Get
            Set(ByVal value As typeMapCoordinate)
                _xml_tmcScanVectorOffset = value
            End Set
        End Property

        Public Property xml_intNumberOfBeams() As Integer
            Get
                Return _xml_intNumberOfBeams
            End Get
            Set(ByVal value As Integer)
                _xml_intNumberOfBeams = value
            End Set
        End Property

        Public Property xml_intNumberOfParticles() As Integer
            Get
                Return _xml_intNumberOfParticles
            End Get
            Set(ByVal value As Integer)
                _xml_intNumberOfParticles = value
            End Set
        End Property

        Public Property xml_intDefaultElevation() As Integer
            Get
                Return _xml_intDefaultElevation
            End Get
            Set(ByVal value As Integer)
                _xml_intDefaultElevation = value
            End Set
        End Property

        Public Property xml_sngLocalizationTime() As Single
            Get
                Return _xml_sngLocalizationTime
            End Get
            Set(ByVal value As Single)
                _xml_sngLocalizationTime = value
            End Set
        End Property

        Public Property xml_intCompassOrientationOffset() As Integer
            Get
                Return _xml_intCompassOrientationOffset
            End Get
            Set(ByVal value As Integer)
                _xml_intCompassOrientationOffset = value
            End Set
        End Property

        Public Property xml_sngAngularVelocityCorrectionFactor() As Single
            Get
                Return _xml_sngAngularVelocityCorrectionFactor
            End Get
            Set(ByVal value As Single)
                _xml_sngAngularVelocityCorrectionFactor = value
            End Set
        End Property

        Public Property xml_sngSteeringBiasOffsetCorrection() As Single
            Get
                Return _xml_sngSteeringBiasOffsetCorrection
            End Get
            Set(ByVal value As Single)
                _xml_sngSteeringBiasOffsetCorrection = value
            End Set
        End Property

        Public Property xml_sngDistanceCorrectionCoeff_x0() As Single
            Get
                Return _xml_sngDistanceCorrectionCoeff_x0
            End Get
            Set(ByVal value As Single)
                _xml_sngDistanceCorrectionCoeff_x0 = value
            End Set
        End Property

        Public Property xml_sngDistanceCorrectionCoeff_x1() As Single
            Get
                Return _xml_sngDistanceCorrectionCoeff_x1
            End Get
            Set(ByVal value As Single)
                _xml_sngDistanceCorrectionCoeff_x1 = value
            End Set
        End Property

        Public Property xml_sngDistanceCorrectionCoeff_x2() As Single
            Get
                Return _xml_sngDistanceCorrectionCoeff_x2
            End Get
            Set(ByVal value As Single)
                _xml_sngDistanceCorrectionCoeff_x2 = value
            End Set
        End Property

        Public Property xml_sngBotLinearAcceleration() As Single
            Get
                Return _xml_sngBotLinearAcceleration
            End Get
            Set(ByVal value As Single)
                _xml_sngBotLinearAcceleration = value
            End Set
        End Property

        Public Property xml_sngBotLinearVelocity() As Single
            Get
                Return _xml_sngBotLinearVelocity
            End Get
            Set(ByVal value As Single)
                _xml_sngBotLinearVelocity = value
            End Set
        End Property

        Public Property xml_sngBotAngularVelocity() As Single
            Get
                Return _xml_sngBotAngularVelocity
            End Get
            Set(ByVal value As Single)
                _xml_sngBotAngularVelocity = value
            End Set
        End Property

        Public Property xml_sngBotAngularAcceleration() As Single
            Get
                Return _xml_sngBotAngularAcceleration
            End Get
            Set(ByVal value As Single)
                _xml_sngBotAngularAcceleration = value
            End Set
        End Property

        Public Property xml_sngBotWheelSeparation() As Single
            Get
                Return _xml_sngBotWheelSeparation
            End Get
            Set(ByVal value As Single)
                _xml_sngBotWheelSeparation = value
            End Set
        End Property

        Public Property xml_intPowerMoving() As Integer
            Get
                Return _xml_intPowerMoving
            End Get
            Set(ByVal value As Integer)
                _xml_intPowerMoving = value
            End Set
        End Property

        Public Property xml_intPowerStopped() As Integer
            Get
                Return _xml_intPowerStopped
            End Get
            Set(ByVal value As Integer)
                _xml_intPowerStopped = value
            End Set
        End Property

        Public Property xml_intNumberOfBeamsDefault() As Integer
            Get
                Return _xml_intNumberOfBeamsDefault
            End Get
            Set(ByVal value As Integer)
                _xml_intNumberOfBeamsDefault = value
            End Set
        End Property

        Public Property xml_sngCameraFOV() As Single
            Get
                Return _xml_sngCameraFOV
            End Get
            Set(ByVal value As Single)
                _xml_sngCameraFOV = value
            End Set
        End Property

        Public Property xml_ticCameraResolution() As typeImageCoordinate
            Get
                Return _xml_ticCameraResolution
            End Get
            Set(ByVal value As typeImageCoordinate)
                _xml_ticCameraResolution = value
            End Set
        End Property

        Public Property xml_sngBotMovementAccuracy() As Single
            Get
                Return _xml_sngBotMovementAccuracy
            End Get
            Set(ByVal value As Single)
                _xml_sngBotMovementAccuracy = value
            End Set
        End Property

        Public Property xml_sngCameraOffset() As Single
            Get
                Return _xml_sngCameraOffset
            End Get
            Set(ByVal value As Single)
                _xml_sngCameraOffset = value
            End Set
        End Property

        Public Property xml_sngZoom() As Single
            Get
                Return _xml_sngZoom
            End Get
            Set(ByVal value As Single)
                _xml_sngZoom = value
            End Set
        End Property


        Public Property xml_strNewsURL() As String
            Get
                Return _xml_strNewsURL
            End Get
            Set(ByVal value As String)
                _xml_strNewsURL = value
            End Set
        End Property

        Public Property xml_strWeatherURL() As String
            Get
                Return _xml_strWeatherURL
            End Get
            Set(ByVal value As String)
                _xml_strWeatherURL = value
            End Set
        End Property

        Public Property xml_strPassword() As String
            Get
                Return _xml_strPassword
            End Get
            Set(ByVal value As String)
                _xml_strPassword = value
            End Set
        End Property

        Public Property xml_strBotComPort() As String
            Get
                Return _xml_strBotComPort
            End Get
            Set(ByVal value As String)
                _xml_strBotComPort = value
            End Set
        End Property

        Public Property xml_strURGComPort() As String
            Get
                Return _xml_strURGComPort
            End Get
            Set(ByVal value As String)
                _xml_strURGComPort = value
            End Set
        End Property

        Public Property xml_strUnits() As String
            Get
                Return _xml_strUnits
            End Get
            Set(ByVal value As String)
                _xml_strUnits = value
            End Set
        End Property

        Public Property xml_sngMaxTravel() As Single
            Get
                Return _xml_sngMaxTravel
            End Get
            Set(ByVal value As Single)
                _xml_sngMaxTravel = value
            End Set
        End Property

        Public Property xml_tbpBotPose() As typeBotPose
            Get
                Return _xml_tbpBotPose
            End Get
            Set(ByVal value As typeBotPose)
                _xml_tbpBotPose = value
            End Set
        End Property

        Public Property xml_trfRangeFinders() As typeRangeFinder()
            Get
                Return _xml_trfRangeFinders
            End Get
            Set(ByVal value As typeRangeFinder())
                For i = 0 To UBound(trfRangeFinders) - 1
                    _xml_trfRangeFinders(i) = value(i)
                Next i
            End Set
        End Property

        Public Property xml_intRangeCorrectionFactor() As Integer()

            Get
                Return _xml_intRangeCorrectionFactor
            End Get
            Set(ByVal value As Integer())
                For i = 0 To UBound(intRangeCorrectionFactor) - 1
                    _xml_intRangeCorrectionFactor(i) = value(i)
                Next i
            End Set
        End Property

        Public Property xml_Robot_IPAddress() As String
            Get
                Return _xml_Robot_IPAddress
            End Get
            Set(ByVal value As String)
                _xml_Robot_IPAddress = value
            End Set
        End Property

        Public Property xml_Robot_Port() As Integer
            Get
                Return _xml_Robot_Port
            End Get
            Set(ByVal value As Integer)
                _xml_Robot_Port = value
            End Set
        End Property
        Public Property xml_sngBotDiameter() As Single
            Get
                Return _xml_sngBotDiameter
            End Get
            Set(ByVal value As Single)
                _xml_sngBotDiameter = value
            End Set
        End Property
        Public Property xml_sngGridSize() As Single
            Get
                Return _xml_sngGridSize
            End Get
            Set(ByVal value As Single)
                _xml_sngGridSize = value
            End Set
        End Property

        Public Property xml_LandMark() As typeLandMark()
            Get
                Return _xml_LandMark
            End Get
            Set(ByVal value As typeLandMark())
                For i = 0 To UBound(tlmLandMarkArray)
                    _xml_LandMark(i) = value(i)
                Next i
            End Set
        End Property

        Public Property xml_RangeLandMark() As typeLandMark()
            Get
                Return _xml_RangeLandMark
            End Get
            Set(ByVal value As typeLandMark())
                For i = 0 To UBound(tlm2DScanLandMarkArray)
                    _xml_RangeLandMark(i) = value(i)
                Next i
            End Set
        End Property

        Public Property xml_boolPCVoice() As Boolean
            Get
                Return _xml_boolPCVoice
            End Get
            Set(ByVal value As Boolean)
                _xml_boolPCVoice = value
            End Set
        End Property

        Public Property xml_boolEnableBotSerialIF() As Boolean
            Get
                Return _xml_boolEnableBotSerialIF
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableBotSerialIF = value
            End Set
        End Property

        Public Property xml_boolVoiceCommandEnable() As Boolean
            Get
                Return _xml_boolVoiceCommandEnable
            End Get
            Set(ByVal value As Boolean)
                _xml_boolVoiceCommandEnable = value
            End Set
        End Property

        Public Property xml_boolShowMore() As Boolean
            Get
                Return _xml_boolShowMore
            End Get
            Set(ByVal value As Boolean)
                _xml_boolShowMore = value
            End Set
        End Property

        Public Property xml_boolVerboseLogFile() As Boolean
            Get
                Return _xml_boolVerboseLogFile
            End Get
            Set(ByVal value As Boolean)
                _xml_boolVerboseLogFile = value
            End Set
        End Property

        Public Property xml_boolEnableYRotation() As Boolean
            Get
                Return _xml_boolEnableYRotation
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableYRotation = value
            End Set
        End Property

        Public Property xml_boolSimulatedMovement() As Boolean
            Get
                Return _xml_boolSimulatedMovement
            End Get
            Set(ByVal value As Boolean)
                _xml_boolSimulatedMovement = value
            End Set
        End Property

        Public Property xml_mnuEnableLocalRCC() As Boolean
            Get
                Return _xml_mnuEnableLocalRCC
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableLocalRCC = value
            End Set
        End Property

        Public Property xml_mnuEnableGotAGlyph() As Boolean
            Get
                Return _xml_mnuEnableGotAGlyph
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableGotAGlyph = value
            End Set
        End Property

        Public Property xml_mnuEnableArm() As Boolean
            Get
                Return _xml_mnuEnableArm
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableArm = value
            End Set
        End Property

        Public Property xml_mnuboolEnableFaceRecognition() As Boolean
            Get
                Return _xml_mnuboolEnableFaceRecognition
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuboolEnableFaceRecognition = value
            End Set
        End Property

        Public Property xml_mnuboolEnableVideo() As Boolean
            Get
                Return _xml_mnuboolEnableVideo
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuboolEnableVideo = value
            End Set
        End Property

        Public Property xml_mnuEnableAVM() As Boolean
            Get
                Return _xml_mnuEnableAVM
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableAVM = value
            End Set
        End Property

        Public Property xml_mnuEnableLocalRR() As Boolean
            Get
                Return _xml_mnuEnableLocalRR
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableLocalRR = value
            End Set
        End Property

        Public Property xml_mnuEnableBotRCC() As Boolean
            Get
                Return _xml_mnuEnableBotRCC
            End Get
            Set(ByVal value As Boolean)
                _xml_mnuEnableBotRCC = value
            End Set
        End Property

        Public Property xml_boolViewLM() As Boolean
            Get
                Return _xml_boolViewLM
            End Get
            Set(ByVal value As Boolean)
                _xml_boolViewLM = value
            End Set
        End Property

        Public Property xml_boolViewDebug() As Boolean
            Get
                Return _xml_boolViewDebug
            End Get
            Set(ByVal value As Boolean)
                _xml_boolViewDebug = value
            End Set
        End Property

        Public Property xml_boolEnableLocalizationWhileMoving() As Boolean
            Get
                Return _xml_boolEnableLocalizationWhileMoving
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableLocalizationWhileMoving = value
            End Set
        End Property

        Public Property xml_boolEnableCourseCorrection() As Boolean
            Get
                Return _xml_boolEnableCourseCorrection
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableCourseCorrection = value
            End Set
        End Property

        Public Property xml_boolEnableRBPF() As Boolean
            Get
                Return _xml_boolEnableRBPF
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableRBPF = value
            End Set
        End Property

        Public Property xml_boolEnableXY_Motion() As Boolean
            Get
                Return _xml_boolEnableXY_Motion
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableXY_Motion = value
            End Set
        End Property

        Public Property xml_boolMute() As Boolean
            Get
                Return _xml_boolMute
            End Get
            Set(ByVal value As Boolean)
                _xml_boolMute = value
            End Set
        End Property

        Public Property xml_boolLogFileEnable() As Boolean
            Get
                Return _xml_boolLogFileEnable
            End Get
            Set(ByVal value As Boolean)
                _xml_boolLogFileEnable = value
            End Set
        End Property

        Public Property xml_boolHeroSelected() As Boolean
            Get
                Return _xml_boolHeroSelected
            End Get
            Set(ByVal value As Boolean)
                _xml_boolHeroSelected = value
            End Set
        End Property

        Public Property xml_boolER1Selected() As Boolean
            Get
                Return _xml_boolER1Selected
            End Get
            Set(ByVal value As Boolean)
                _xml_boolER1Selected = value
            End Set
        End Property

        Public Property xml_boolEnableBumperSwitches_ER1() As Boolean
            Get
                Return _xml_boolEnableBumperSwitches_ER1
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableBumperSwitches_ER1 = value
            End Set
        End Property

        Public Property xml_boolEnableEvolutionIR_ER1() As Boolean
            Get
                Return _xml_boolEnableEvolutionIR_ER1
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableEvolutionIR_ER1 = value
            End Set
        End Property

        Public Property xml_intVideoSource() As Integer
            Get
                Return _xml_intVideoSource
            End Get
            Set(ByVal value As Integer)
                _xml_intVideoSource = value
            End Set
        End Property

        Public Property xml_boolEnableRangerAveraging() As Boolean
            Get
                Return _xml_boolEnableRangerAveraging
            End Get
            Set(ByVal value As Boolean)
                _xml_boolEnableRangerAveraging = value
            End Set
        End Property

        Public Property xml_boolRoboRealmBotSelected() As Boolean
            Get
                Return _xml_boolRoboRealmBotSelected
            End Get
            Set(ByVal value As Boolean)
                _xml_boolRoboRealmBotSelected = value
            End Set
        End Property


        Public Property xml_boolAllowRoboRealmToControlBot() As Boolean
            Get
                Return _xml_boolAllowRoboRealmToControlBot
            End Get
            Set(ByVal value As Boolean)
                _xml_boolAllowRoboRealmToControlBot = value
            End Set
        End Property


        ' Empty constructor required for serialization.
        Public Sub New()
        End Sub

        Public Sub New(
            ByVal _xml_tmcDock As typeMapCoordinate,
            ByVal _xml_intDockOrientation As Integer,
            ByVal _xml_intDockTriggerPC As Integer,
            ByVal _xml_boolDockBackIn As Boolean,
            ByVal _xml_sngDockTriggerBot As Single,
            ByVal _xml_boolRemoteKinect As Boolean,
            ByVal _xml_sngScanFOV As Single,
            ByVal _xml_sngScannerCalibrate As Single,
            ByVal _xml_sngScannerCurveAdjust As Single,
            ByVal _xml_intScanOffsetDegrees As Short,
            ByVal _xml_ipKinectAddress As String,
            ByVal _xml_Robot_IPAddress As String,
            ByVal _xml_tmcDestinationAlpha As typeMapCoordinate,
            ByVal _xml_tmcDestinationBravo As typeMapCoordinate,
            ByVal _xml_tmcDestinationCharlie As typeMapCoordinate,
            ByVal _xml_tmcDestinationDelta As typeMapCoordinate,
            ByVal _xml_tmcDestinationEcho As typeMapCoordinate,
            ByVal _xml_tmcScanVectorOffset As typeMapCoordinate,
            ByVal _xml_intNumberOfBeams As Integer,
            ByVal _xml_intNumberOfParticles As Integer,
            ByVal _xml_intDefaultElevation As Integer,
            ByVal _xml_Robot_Port As Integer,
            ByVal _xml_sngLocalizationTime As Single,
            ByVal _xml_intCompassOrientationOffset As Integer,
            ByVal _xml_sngAngularVelocityCorrectionFactor As Single,
            ByVal _xml_sngSteeringBiasOffsetCorrection As Single,
            ByVal _xml_sngDistanceCorrectionCoeff_x0 As Single,
            ByVal _xml_sngDistanceCorrectionCoeff_x1 As Single,
            ByVal _xml_sngDistanceCorrectionCoeff_x2 As Single,
            ByVal _xml_sngBotLinearAcceleration As Single,
            ByVal _xml_sngBotLinearVelocity As Single,
            ByVal _xml_sngBotAngularVelocity As Single,
            ByVal _xml_sngBotAngularAcceleration As Single,
            ByVal _xml_sngBotWheelSeparation As Single,
            ByVal _xml_intPowerMoving As Integer,
            ByVal _xml_intPowerStopped As Integer,
            ByVal _xml_intNumberOfBeamsDefault As Integer,
            ByVal _xml_strNewsURL As String,
            ByVal _xml_strWeatherURL As String,
            ByVal _xml_strPassword As String,
            ByVal _xml_sngBotDiameter As Single,
            ByVal _xml_sngCameraFOV As Single,
            ByVal _xml_ticCameraResolution As typeImageCoordinate,
            ByVal _xml_sngBotMovementAccuracy As Single,
            ByVal _xml_sngCameraOffset As Single,
            ByVal _xml_sngMaxTravel As Single,
            ByVal _xml_sngGridSize As Single,
            ByVal _xml_sngZoom As Single,
            ByVal _xml_strBotComPort As String,
            ByVal _xml_strURGComPort As String,
            ByVal _xml_strUnits As String,
            ByVal _xml_tbpBotPose As typeBotPose,
            ByVal _xml_intRangeCorrectionFactor() As Integer,
            ByVal _xml_LandMark() As typeLandMark,
            ByVal _xml_RangeLandMark() As typeLandMark,
            ByVal _xml_boolEnableBotSerialIF As Boolean,
            ByVal _xml_boolPCVoice As Boolean,
            ByVal _xml_boolVoiceCommandEnable As Boolean,
            ByVal _xml_boolShowMore As Boolean,
            ByVal _xml_boolVerboseLogFile As Boolean,
            ByVal _xml_boolEnableYRotation As Boolean,
            ByVal _xml_boolSimulatedMovement As Boolean,
            ByVal _xml_mnuEnableLocalRCC As Boolean,
            ByVal _xml_mnuEnableGotAGlyph As Boolean,
            ByVal _xml_mnuEnableArm As Boolean,
            ByVal _xml_mnuboolEnableFaceRecognition As Boolean,
            ByVal _xml_mnuboolEnableVideo As Boolean,
            ByVal _xml_mnuAVM As Boolean,
            ByVal _xml_mnuEnableLocalRR As Boolean,
            ByVal _xml_mnuEnableBotRCC As Boolean,
            ByVal _xml_boolViewLM As Boolean,
            ByVal _xml_boolViewDebug As Boolean,
            ByVal _xml_boolEnableLocalizationWhileMoving As Boolean,
            ByVal _xml_boolEnableCourseCorrection As Boolean,
            ByVal _xml_boolEnableRBPF As Boolean,
            ByVal _xml_boolEnableXY_Motion As Boolean,
            ByVal _xml_boolMute As Boolean,
            ByVal _xml_boolLogFileEnable As Boolean,
            ByVal _xml_boolHeroSelected As Boolean,
            ByVal _xml_boolER1Selected As Boolean,
            ByVal _xml_boolEnableBumperSwitches_ER1 As Boolean,
            ByVal _xml_boolEnableEvolutionIR_ER1 As Boolean,
            ByVal _xml_intVideoSource As Integer,
            ByVal _xml_boolEnableRangerAveraging As Boolean,
            ByVal _xml_boolRoboRealmBotSelected As Boolean,
            ByVal _xml_boolAllowRoboRealmToControlBot As Boolean
                )
            Try
                tmcDock = xml_tmcDock
                intDockOrientation = xml_intDockOrientation
                intDockTriggerPC = xml_intDockTriggerPC
                boolDockBackIn = xml_boolDockBackIn
                sngDockTriggerBot = xml_sngDockTriggerBot
                boolRemoteKinect = xml_boolRemoteKinect
                sngScanFOV = xml_sngScanFOV
                sngScannerCalibrate = xml_sngScannerCalibrate
                sngScannerCurveAdjust = xml_sngScannerCurveAdjust
                intScanOffsetDegrees = xml_intScanOffsetDegrees
                ipKinectAddress = IPAddress.Parse(xml_ipKinectAddress.Trim)
                tmcDestinationAlpha = xml_tmcDestinationAlpha
                tmcDestinationBravo = xml_tmcDestinationBravo
                tmcDestinationCharlie = xml_tmcDestinationCharlie
                tmcDestinationDelta = xml_tmcDestinationDelta
                tmcDestinationEcho = xml_tmcDestinationEcho
                tmcScanVectorOffset = xml_tmcScanVectorOffset
                intNumberOfBeams = xml_intNumberOfBeams
                intNumberOfParticles = xml_intNumberOfParticles
                intDefaultElevation = xml_intDefaultElevation
                ipRobot_IPAddress = IPAddress.Parse(xml_Robot_IPAddress.Trim)
                intRobot_Port = xml_Robot_Port
                sngSteeringBiasOffsetCorrection = xml_sngSteeringBiasOffsetCorrection
                sngDistanceCorrectionCoeff_x0 = xml_sngDistanceCorrectionCoeff_x0
                sngDistanceCorrectionCoeff_x1 = xml_sngDistanceCorrectionCoeff_x1
                sngDistanceCorrectionCoeff_x2 = xml_sngDistanceCorrectionCoeff_x2
                sngBotLinearAcceleration = xml_sngBotLinearAcceleration
                sngBotLinearVelocity = xml_sngBotLinearVelocity
                sngBotAngularVelocity = xml_sngBotAngularVelocity
                sngBotAngularAcceleration = xml_sngBotAngularAcceleration
                sngBotWheelSeparation = xml_sngBotWheelSeparation
                intPowerMoving = xml_intPowerMoving
                intPowerStopped = xml_intPowerStopped
                intNumberOfBeamsDefault = xml_intNumberOfBeamsDefault
                sngLocalizationTime = xml_sngLocalizationTime
                intCompassOrientationOffset = xml_intCompassOrientationOffset
                sngAngularVelocityCorrectionFactor = xml_sngAngularVelocityCorrectionFactor
                If (xml_strNewsURL <> "") Then strNewsURL = xml_strNewsURL
                If (xml_strWeatherURL <> "") Then strWeatherURL = xml_strWeatherURL
                strPassword = xml_strPassword
                sngBotDiameter = xml_sngBotDiameter
                sngCameraFOV = xml_sngCameraFOV
                ticCameraResolution = xml_ticCameraResolution
                sngBotMovementAccuracy = xml_sngBotMovementAccuracy
                sngCameraOffset = xml_sngCameraOffset
                sngMaxTravel = xml_sngMaxTravel
                sngZoom = xml_sngZoom
                sngGridSize = xml_sngGridSize
                tbpBotPose.Location = xml_tbpBotPose.Location
                tbpBotPose.LocationUncertainty = xml_tbpBotPose.LocationUncertainty
                tbpBotPose.Orientation = xml_tbpBotPose.Orientation
                tbpBotPose.OrientationUncertainty = xml_tbpBotPose.OrientationUncertainty
                For i = 0 To UBound(trfRangeFinders)
                    trfRangeFinders(i) = xml_trfRangeFinders(i)
                Next i
                For i = 0 To UBound(intRangeCorrectionFactor)
                    intRangeCorrectionFactor(i) = xml_intRangeCorrectionFactor(i)
                Next i
                For i = 0 To UBound(tlmLandMarkArray)
                    tlmLandMarkArray(i) = xml_LandMark(i)
                Next i
                For i = 0 To UBound(tlm2DScanLandMarkArray)
                    tlm2DScanLandMarkArray(i) = xml_RangeLandMark(i)
                Next i
                boolEnableBotSerialIF = xml_boolEnableBotSerialIF
                boolPCVoice = xml_boolPCVoice
                boolVoiceCommandEnable = xml_boolVoiceCommandEnable
                boolShowMore = xml_boolShowMore
                boolVerboseLogFile = xml_boolVerboseLogFile
                boolEnableYRotation = xml_boolEnableYRotation
                boolSimulatedMovement = xml_boolSimulatedMovement
                boolEnableLocalRCC = xml_mnuEnableLocalRCC
                boolEnableGotAGlyph = xml_mnuEnableGotAGlyph
                boolEnableArm = xml_mnuEnableArm
                boolEnableFaceRecognition = xml_mnuboolEnableFaceRecognition
                boolEnableVideo = xml_mnuboolEnableVideo
                boolEnableAVM = xml_mnuEnableAVM
                boolEnableLocalRR = xml_mnuEnableLocalRR
                boolEnableBotRCC = xml_mnuEnableBotRCC
                boolViewLM = xml_boolViewLM
                boolViewDebug = xml_boolViewDebug
                boolEnableLocalizationWhileMoving = xml_boolEnableLocalizationWhileMoving
                boolEnableCourseCorrection = xml_boolEnableCourseCorrection
                boolEnableRBPF = xml_boolEnableRBPF
                boolEnableCurveMotion = xml_boolEnableXY_Motion
                boolMute = xml_boolMute
                boolLogFileEnable = xml_boolLogFileEnable
                boolHeroSelected = xml_boolHeroSelected
                boolER1Selected = xml_boolER1Selected
                boolEnableBumperSwitches_ER1 = xml_boolEnableBumperSwitches_ER1
                boolEnableEvolutionIR_ER1 = xml_boolEnableEvolutionIR_ER1
                intVideoSource = xml_intVideoSource
                boolEnableRangerAveraging = xml_boolEnableRangerAveraging
                boolRoboRealmBotSelected = xml_boolRoboRealmBotSelected
                boolAllowRoboRealmToControlBot = xml_boolAllowRoboRealmToControlBot
            Catch ex As Exception
                frmDebug.subWriteLogs(" EXCEPTION in New")
            End Try
        End Sub



        Public Sub SaveSettingsXml(ByVal path As String)
            On Error Resume Next
            Dim xserializer As New XmlSerializer(Me.GetType)
            Using file As New FileStream(path, FileMode.Create)
                xserializer.Serialize(file, Me)
            End Using
        End Sub

        Public Shared Function LoadSettingsXml(ByVal path As String) As BotSettings
            On Error Resume Next
            Dim deserializer As New XmlSerializer(GetType(BotSettings))
            Using file As New FileStream(path, FileMode.Open)
                Return DirectCast(deserializer.Deserialize(file), BotSettings)
            End Using
        End Function



    End Class




End Module




