﻿Imports System.Threading
Imports System.Drawing


Module modBackground
    Public Class classBackground

        Public Sub subBackgroundMonitor()
            ' Background Thread
            '    updates Bot's odometry and collision
            '    monitors 'moving' and sets tmiMoveInfo.boolBotIsMoving to FALSE at end of move
            Try
                Thread.CurrentThread.Name = "threadBackground"
                While Not boolShutDown
                    If tmiMoveInfo.boolBotIsMoving Then ' 
                        Do
                            tbpBotPose = ftnLocalizeUsingOdometry(tbpBotPose)
                            subSlamBackground()
                            If (ftnCheckForCollision()) Then tbpBotPose = ftnCollisionRecovery(tbpBotPose)
                            Thread.Sleep(50)
                        Loop Until CBool(InStr(ftnSendCommand("moving"), "False"))
                        If boolDebugOdometry Then frmDebug.subWriteLogs(ftnElapsedTimeS() & "  subBackgroundMonitor :  moving = False")
                        ftnSetMoveInfo(tmiMoveInfo.tomTypeOfMove, tmiMoveInfo.tbpStartingPose, tmiMoveInfo.tbpTargetPose, False)
                    End If
                    Thread.Sleep(550)
                End While
            Catch ex As Exception
                frmDebug.subWriteLogs(" EXCEPTION in subBackgroundMonitor " & ex.ToString)
            End Try
        End Sub


        Sub subSlamBackground()
            Try
                If boolSlam Then 'And (tmiMoveInfo.tomTypeOfMove <> TypeOfMove.TURN) Then
                    Dim boolGoodLocalization As Boolean = False
                    frmDebug.subWriteShortPose(ftnElapsedTimeS() & " ==============   subSlamBackground::  tbpBotPose ", tbpBotPose)
                    tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                End If
            Catch ex As Exception
                frmDebug.subWriteLogs(" EXCEPTION in subSlamBackground " & ex.ToString)
            End Try
        End Sub

    End Class
End Module
